-- CherokeeTrait
-- Author: h_Griff0n
-- DateCreated: 9/9/2012 5:59:39 PM
--------------------------------------------------------------
GameEvents.PlayerDoTurn.Add(function(iPlayer) 

	local pPlayer = Players[iPlayer]; -- Sets the player as a local variable
	local playerStartPlot = pPlayer:GetStartingPlot(); -- Sets a plot on which to base the spawn
	local savedData = Modding.OpenSaveData(); -- Unknown

	local iValue = savedData.GetValue("NextGuerillaTurn");  -- Gets a turn on which to spawn the Guerrilas
	if (iValue ~= nil) then

		if (Game.GetGameTurn() == iValue) then -- Compare the number to the turn
		
			-- Korea
			if (playerStartPlot:GetX() == ChinaKoreaCities[iSeoulIndex].X and playerStartPlot:GetY() == ChinaKoreaCities[iSeoulIndex].Y) then -- Compares start plot to a list of cities
				AddKoreaGuerillas(); -- Adds Guerilla units
				iValue = iValue + Game.Rand(6, "Next guerilla arrival") + 7; -- Increases the turn on which to spawn guerillas
				savedData.SetValue("NextGuerillaTurn", iValue); -- Sets the savedData turn to the increased turn
				print ("New Guerilla Turn: " .. tostring(iValue)); -- Prints to lua console
			end
		end
	end
end);

function AddKoreaGuerillas()

	local iKoreanCitiesCapturedByJapan = 0;
	local iJapan;
	local iKorea;
	local pPlayer;
	local iUnitID;
	local unit;

	-- Find Japan
	for iPlayerLoop = 0, 3, 1 do -- Loops through game players to find Japan and Korea
		pPlayer = Players[iPlayerLoop];
		local playerStartPlot = pPlayer:GetStartingPlot();

		if (playerStartPlot:GetX() == iKyotoX and playerStartPlot:GetY() == iKyotoY) then
			iJapan = iPlayerLoop;
		elseif (playerStartPlot:GetX() == ChinaKoreaCities[iSeoulIndex].X and playerStartPlot:GetY() == ChinaKoreaCities[iSeoulIndex].Y) then
			iKorea = iPlayerLoop;
		end
	end


	-- Find out who controls all the cities of China-Korea
	for i, city in ipairs(ChinaKoreaCities) do

		-- Korea only
		if (ChinaKoreaCities[i].X > 23) then -- If chosen city is Korean
	
			local pPlot = Map.GetPlot(ChinaKoreaCities[i].X, ChinaKoreaCities[i].Y);
			local pCity = pPlot:GetPlotCity();
			if (pCity ~= nil) then
				if (pCity:GetOwner() == iJapan) then -- If chosen city is controlled by Japan
			    		iKoreanCitiesCapturedByJapan = iKoreanCitiesCapturedByJapan + 1; -- Increases counter
				end
			else
				print ("Scripting error.");
			end
		end
	end

	-- One-third of units are Turtle Ships, Two-thirds guerillas
	local iTurtleShips = iKoreanCitiesCapturedByJapan / 3; -- Generates guerilla units based on the number of cities Japan controls
	local iGuerillas = iKoreanCitiesCapturedByJapan - iTurtleShips;

	pPlayer = Players[iKorea]; -- Give guerilla units
	local iX, iY, iRand;
	for iLoop = 1, iTurtleShips, 1 do
		iUnitID = GameInfoTypes["UNIT_KOREAN_TURTLE_SHIP"];
		iRand = Game.Rand(4, "Turtle ship start");
		if (iRand == 0) then
			iX = 23;
			iY = 29;
		elseif (iRand == 1) then
			iX = 18;
			iY = 27;
		elseif (iRand == 2) then
			iX = 28;
			iY = 8;
		else
			iX = 33;
			iY = 31;
		end
		unit = pPlayer:InitUnit (iUnitID, iX, iY);
		unit:JumpToNearestValidPlot();
	end

	for iLoop = 1, iGuerillas, 1 do
		iRand = iLoop % 6;
		if (iRand == 1) then
			iX = 31;
			iY = 17;
		elseif (iRand == 2) then
			iX = 31;
			iY = 16;
		elseif (iRand == 3) then
			iX = 32;
			iY = 24;
		elseif (iRand == 4) then
			iX = 32;
			iY = 23;
		elseif (iRand == 5) then
			iX = 29;
			iY = 20;
		else
			iX = 28;
			iY = 19;
		end
		iRand = Game.Rand(4, "Unit type");
		if (iRand < 2) then
			iUnitID = GameInfoTypes["UNIT_ARCHER"];
		elseif (iRand == 2) then
			iUnitID = GameInfoTypes["UNIT_PIKEMAN"];
		else
			iUnitID = GameInfoTypes["UNIT_MUSKETMAN"];
		end

		unit = pPlayer:InitUnit (iUnitID, iX, iY);
		if (iUnitID == GameInfoTypes["UNIT_ARCHER"]) then
			local iPromotionID = GameInfoTypes["PROMOTION_GUERILLA_WITHDRAW"];
			unit:SetHasPromotion(iPromotionID, true);
		end
	end
	
	-- Put up dialog box
	local popupInfo = {
		Data1 = 500,
		Type = ButtonPopupTypes.BUTTONPOPUP_TEXT,
		Text = Locale.ConvertTextKey("TXT_KEY_CHEROKEE_GUERILLAS_SPAWNED");
	}
	UI.AddPopup(popupInfo);

	print ("Finished adding Korean guerillas (Turtle Ships, Melee): (" .. tostring(iTurtleShips) .. ", " .. tostring(iGuerillas) .. ")");
end